import { world, EquipmentSlot, EntityEquippableComponent, system, ItemDurabilityComponent } from '@minecraft/server';

world.beforeEvents.itemUseOn.subscribe((eventData) => {
    const block = eventData.block;
    const player = eventData.source;
    const face = eventData.blockFace;
    const mainhand = player.getComponent(EntityEquippableComponent.componentId).getEquipmentSlot(EquipmentSlot.Mainhand);
    const item = mainhand.getItem();
    // Deepslate
    if (block.typeId === "minecraft:deepslate" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_deepslate");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Quartz Block
    else if (block.typeId === "minecraft:quartz_block" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_quartz_block");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Nether Bricks
    else if (block.typeId === "minecraft:nether_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_nether_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Polished Blackstone Bricks
    else if (block.typeId === "minecraft:polished_blackstone" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_polished_blackstone");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Stone Bricks
    else if (block.typeId === "minecraft:stone_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_stone_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Infested Stone Bricks
    else if (block.typeId === "minecraft:infested_stone_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:infested_chiseled_stone_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Red Sandstone
    else if (block.typeId === "minecraft:red_sandstone" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_red_sandstone");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Sandstone
    else if (block.typeId === "minecraft:sandstone" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_sandstone");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Tuff
    else if (block.typeId === "minecraft:tuff" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_tuff");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Tuff Bricks
    else if (block.typeId === "minecraft:tuff_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_tuff_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Waxed Copper
    else if (block.typeId === "minecraft:waxed_copper" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:waxed_chiseled_copper");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Waxed Exposed Copper
    else if (block.typeId === "minecraft:exposed_copper" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:exposed_chiseled_copper");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Waxed Weathered Copper
    else if (block.typeId === "minecraft:waxed_weathered_copper" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:waxed_weathered_chiseled_copper");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Waxed Oxidized Copper
    else if (block.typeId === "minecraft:waxed_oxidized_copper" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:waxed_oxidized_chiseled_copper");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Copper
    else if (block.typeId === "minecraft:copper" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:chiseled_copper");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Exposed Copper
    else if (block.typeId === "minecraft:exposed_copper" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:exposed_chiseled_copper");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Weathered Copper
    else if (block.typeId === "minecraft:weathered_copper" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:weathered_chiseled_copper");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Oxidized Copper
    else if (block.typeId === "minecraft:oxidized_copper" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:chisel")) {
            system.run(() => {
                block.setType("minecraft:oxidized_chiseled_copper");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
})
function reduceDurability(player, item, reduceAmount) {
    if (player.getGameMode() !== 'survival') return item;
    const comp = item.getComponent(ItemDurabilityComponent.componentId);
    if (!comp) return item;
    const reducedAmount = reduceAmount + comp.damage;
    if (reducedAmount >= comp.maxDurability) {
        world.playSound("random.break", player.location);
        return undefined;
    } else {
        comp.damage = reducedAmount;
        return item;
    }
}

