import { world, EquipmentSlot, EntityEquippableComponent, system, ItemDurabilityComponent } from '@minecraft/server';

world.beforeEvents.itemUseOn.subscribe((eventData) => {
    const block = eventData.block;
    const player = eventData.source;
    const face = eventData.blockFace;
    const mainhand = player.getComponent(EntityEquippableComponent.componentId).getEquipmentSlot(EquipmentSlot.Mainhand);
    const item = mainhand.getItem();
    // Deepslate Bricks
    if (block.typeId === "minecraft:deepslate_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:hammer")) {
            system.run(() => {
                block.setType("minecraft:cracked_deepslate_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Deepslate Tiles
    else if (block.typeId === "minecraft:deepslate_tiles" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:hammer")) {
            system.run(() => {
                block.setType("minecraft:cracked_deepslate_tiles");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Nether Bricks
    else if (block.typeId === "minecraft:nether_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:hammer")) {
            system.run(() => {
                block.setType("minecraft:cracked_nether_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Polished Blackstone Bricks
    else if (block.typeId === "minecraft:polished_blackstone_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:hammer")) {
            system.run(() => {
                block.setType("minecraft:cracked_polished_blackstone_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Stone Bricks
    else if (block.typeId === "minecraft:stone_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:hammer")) {
            system.run(() => {
                block.setType("minecraft:cracked_stone_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
    // Infested Stone Bricks
    else if (block.typeId === "minecraft:infested_stone_bricks" && face !== "Down") {
        if (mainhand?.hasTag("kana_ca:hammer")) {
            system.run(() => {
                block.setType("minecraft:infested_cracked_stone_bricks");
                mainhand.setItem(reduceDurability(player, item, 1));
                player.playSound("use.stone", { location: block });
            });
        }
    }
})
function reduceDurability(player, item, reduceAmount) {
    if (player.getGameMode() !== 'survival') return item;
    const comp = item.getComponent(ItemDurabilityComponent.componentId);
    if (!comp) return item;
    const reducedAmount = reduceAmount + comp.damage;
    if (reducedAmount >= comp.maxDurability) {
        world.playSound("random.break", player.location);
        return undefined;
    } else {
        comp.damage = reducedAmount;
        return item;
    }
}

